#include <iostream>

void use_after_free() {
  int *a = new int;

  delete a;

  *a = 5;
}

void use_after_free_array() {
  int *a = new int[5];

  delete[] a;

  a[4] = 6;
}

void wrong_delete() {
  int *a = new int;
  delete[] a;
}

void wrong_delete2() {
  int *a = new int[5];
  delete a;
}

void write_past_array() {
  int *a = new int[3];

  a[3] = 5;

  delete[] a;
}

void twod_array_bad_delete() {
  int **array = new int *[5];
  for (int i = 0; i < 5; ++i)
    array[i] = new int[10];

  delete[] array;
  for (int i = 0; i < 5; ++i)
    delete[] array[i];
}

int main() {
  //use_after_free();
  //use_after_free_array();
  //wrong_delete();
  //wrong_delete2();
  //write_past_array();
  twod_array_bad_delete();

  return 0;
}
